
function init()
	checkTime = 0
	isTriggered = false   -- If false then the script won't do anything, to improve overall performance
	runTrigger = FindTrigger("run-computer-room", true)
	lights = {}
	local lightShapes = FindShapes("panel-light")
	for i=1, #lightShapes do
		lights[i] = {
			shape = lightShapes[i],
			isOn = true
		}
	end
	computerSound = LoadLoop("MOD/sounds/computer-hum.ogg")
	mainShape = FindShape("computer")
	local min, max = GetShapeBounds(mainShape)
	local boundsSize = VecSub(max, min)
	bodyCenter = VecLerp(min, max, 0.5)
end

function tick(deltaTime)
	checkTime = checkTime + deltaTime
	if checkTime > 2 then
		isTriggered = checkTrigger()
		checkTime = 0
	end
	if isTriggered then
		-- Blinkenlights
		local light = lights[math.random(#lights)]
		if light.isOn then
			SetShapeEmissiveScale(light.shape, 0)
			light.isOn = false
		else
			SetShapeEmissiveScale(light.shape, 1)
			light.isOn = true
		end
		
		if not IsShapeBroken(mainShape) then
			PlayLoop(computerSound, bodyCenter, 0.2)
		end
	end
end

function checkTrigger()
	return IsPointInTrigger(runTrigger, GetPlayerTransform().pos)
end
