
function init()
	checkTime = 0
	isTriggered = false   -- If false then the script won't do anything, to improve overall performance
	numberOfPipes = 16          -- Per side
	distanceBetweenPipes = 1.1  -- Meters
	timeToLive = 8              -- Seconds
	offset = 0
	increment = 1
	locations = FindLocations("mist-start")
	runTriggers = FindTriggers("run")
end

function tick(deltaTime)
	checkTime = checkTime + deltaTime
	if checkTime > 1 then
		isTriggered = checkTrigger()
		checkTime = 0
	end
	if isTriggered then
		--DebugWatch("delta", deltaTime)
		--DebugWatch("offset", offset)
		--DebugWatch("increment", increment)

		-- Set up particle properties
		ParticleReset()
		ParticleType("smoke")
		ParticleColor(0.55, 0.63, 0.68)  -- Light grayish blue
		ParticleAlpha(0.6, 0.1)
		ParticleRadius(0.1, 0.5)
		ParticleCollide(1, 1, "constant", 0.1) --Ramp up collisions quickly, only skipping the first 10% of lifetime
		ParticleGravity(-1.5)
		ParticleDrag(0)
		
		-- When frame rate is low, only spawn particle for every n'th pipe, altering the offset each tick
		-- so as to still disperse evenly.
		if deltaTime > 0.03 then
			if increment < 5 then
				increment = increment + 1
			end
		else
			if increment > 1 then
				increment = increment - 1
			end
		end
		offset = (offset + 1) % increment

		-- Spawn particle at each pipe location
		for i=1, #locations do
			local startTransform = GetLocationTransform(locations[i])
			for j=offset, numberOfPipes - 1, increment do
				local currentPositionTransform = Transform(Vec(0, 0, j * distanceBetweenPipes), QuatEuler(0, 0, 0))
				local worldTransform = TransformToParentTransform(startTransform, currentPositionTransform)
				SpawnParticle(worldTransform.pos, Vec(0, 0, 0), timeToLive)
			end
		end
	end
end

function randomFloat(lower, upper)
	return lower + math.random() * (upper - lower);
end

function checkTrigger()
	local playerPos = GetPlayerTransform().pos
	return IsPointInTrigger(runTriggers[1], playerPos) or
	       IsPointInTrigger(runTriggers[2], playerPos) or
		   IsPointInTrigger(runTriggers[3], playerPos)
end