
function init()
	spawnEnemies()
	nudgeDynamicObjects()
	startFans()
	makeExplosions()
end



function nudgeDynamicObjects()
	local vec = Vec(0, 0.1, 0)
	local bodies = FindBodies("", true)
	for i=1, #bodies do
		if IsBodyDynamic(bodies[i]) then
			SetBodyVelocity(bodies[i], vec)
		end
	end
end



function spawnEnemies()
	local origins = FindLocations("enemy-origin", true)
	local locations = FindLocations("enemy-spawn", true)
	--DebugPrint("Enemies: "..#origins..", Locations: "..#locations)

	shuffle(locations)

	for i=1, #origins do
		local originPos = GetLocationTransform(origins[i]).pos
		local destTrans = GetLocationTransform(locations[i])
		local diff = VecSub(originPos, destTrans.pos)
		local bodies = findBodiesBelongingToEnemy(originPos)
		for j=1, #bodies do
			-- Calculate difference between each bodies's position and the location, then move by that much.
			-- Move each body part relative to the origin.
			local bodyDest = VecSub(GetBodyTransform(bodies[j]).pos, diff)
			SetBodyTransform(bodies[j], Transform(bodyDest, destTrans.rot))
		end
	end
end

function shuffle(list)
	for i = #list, 2, -1 do
		local j = math.random(i)
		list[i], list[j] = list[j], list[i]
	end
end

function findBodiesBelongingToEnemy(centerPos)
	local searchDist = 1.5  -- Meters. Look for shapes +/- this amount from location along all axis.
	local dist = Vec(searchDist, searchDist, searchDist)
	return QueryAabbBodies(VecSub(centerPos, dist), VecAdd(centerPos, dist))
end



function startFans()
	local fans = FindShapes("fan", true)
	for i=1, #fans do
		local joint = GetShapeJoints(fans[i])[1]
		SetJointMotor(joint, 1)
	end
end



function makeExplosions()
	local locations = FindLocations("explosion", true)
	for i=1, #locations do
		Explosion(GetLocationTransform(locations[i]).pos, 2)
	end
end